#include <Bounce.h>
//#include <Wire.h>

// Top Row
Bounce button00 = Bounce(19, 10);
Bounce button01 = Bounce(20, 10);  // 10 = 10 ms debounce time
Bounce button02 = Bounce(21, 10);  // which is appropriate for
Bounce button03 = Bounce( 0, 10);  // most mechanical pushbuttons
Bounce button04 = Bounce( 1, 10);
// Main Row
Bounce button10 = Bounce(18, 10);
Bounce button11 = Bounce(17, 10);
Bounce button12 = Bounce(24, 10);
Bounce button13 = Bounce( 7, 10);
Bounce button14 = Bounce( 2, 10);
// Thumb Row
Bounce button20 = Bounce(16, 10);
Bounce button21 = Bounce(13, 10);
Bounce button22 = Bounce(22, 10);
Bounce button23 = Bounce(10, 10);
Bounce button24 = Bounce( 3, 10);
// Bottom Row
Bounce button31 = Bounce(11, 10);
Bounce button32 = Bounce(23, 10);
Bounce button33 = Bounce( 8, 10);

// Cursor Keys
// UP, DOWN, LEFT, RIGHT, HOME, END, PAGE UP, PAGE DOWN, TAB (9)393931I

// Normal Keys
// KEY_A    .. KEY_Z
// KEY_0    .. KEY_9
// KEY_F1   .. KEY_F12
// KEYPAD_0 .. KEYPAD_9
// KEY_ENTER	    KEY_ESC	    KEY_BACKSPACE   KEY_TAB
// KEY_SPACE	    KEY_MINUS	    KEY_EQUAL	    KEY_LEFT_BRACE
// KEY_RIGHT_BRACE  KEY_BACKSLASH   KEY_NUMBER	    KEY_SEMICOLON
// KEY_QUOTE	    KEY_TILDE       KEY_COMMA	    KEY_PERIOD
// KEY_SLASH	    KEY_CAPS_LOCK   KEY_PRINTSCREEN KEY_SCROLL_LOCK
// KEY_PAUSE	    KEY_INSERT	    KEY_HOME	    KEY_PAGE_UP
// KEY_DELETE	    KEY_END	    KEY_PAGE_DOWN   KEY_RIGHT
// KEY_LEFT	    KEY_DOWN	    KEY_UP	    KEY_NUM_LOCK
// KEYPAD_SLASH	    KEYPAD_ASTERIX  KEYPAD_MINUS    KEYPAD_PLUS
// KEYPAD_ENTER	    KEYPAD_PERIOD

//                00000 10000 01000 11000 00100 10100 01100 11100
byte KeyMap[] = {     0,    1,    2,    6,    3,   10,    7,   13,      //  0..7
//                00010 10010 01010 11010 00110 10110 01110 11110
                      4,    0,   11,    0,    8,    0,   14,   16,     //  8..15
//                00001 10001 01001 11001 00101 10101 01101 11101
                      5,    0,    0,    0,   12,    0,    0,   0,      // 16..23
//                00011 10011 01011 11011 00111 10111 01111 11111
                      9,    0,    0,    0,   15,    0,   17,   18 };   // 24..31

byte Keys000[] = { 0, 255,   KEY_T, KEY_I, KEY_L, KEY_BACKSPACE,    // Single Key
                   0, KEY_G, KEY_Y, KEY_P,                          // Double Pair
                   0, KEY_K, 0,                                     // Double Split
                   0, KEY_F, 0,                                     // Triple
                   0, 0, 0 };                                       // Quad/Quint
byte Keys001[] = { 0, KEY_TAB, KEY_7, KEY_8, KEY_9, KEYPAD_MINUS,   // Thumb + Single Key
                   0, KEY_UP, KEY_DOWN, 0,                          // Thumb + Double Pair
                   0, 0, 0,                                         // Thumb + Double Split
                   0, 0, 0,                                         // Thumb + Triple
                   0, 0, 0 };                                       // Thumb + Quad/Quint

byte Keys010[] = { 0, 253,   KEY_E, KEY_A, KEY_S, KEY_PERIOD,       // Single Key
                   0, KEY_R, KEY_N, KEY_COMMA,                      // Double Pair
                   0, KEY_H, 0,                                     // Double Split
                   0, KEY_M, 0,                                     // Triple
                   0, 0, 0 };                                       // Quad/Quint
byte Keys011[] = { 0, 252, KEY_4, KEY_5, KEY_6, KEYPAD_PLUS,        // Thumb + Single Key
                   0, KEY_LEFT, KEY_RIGHT, 0,                       // Thumb + Double Pair
                   0, 0, 0,                                         // Thumb + Double Split
                   0, KEY_PAGE_UP, 0,                               // Thumb + Triple
                   0, 0, 0 };                                       // Thumb + Quad/Quint

byte Keys020[] = { 0, 0, KEY_O, KEY_U, KEY_C, KEY_ENTER,            // Single Key
                   0, KEY_D, KEY_B, 0,                              // Double Pair
                   0, KEY_V, 0,                                     // Double Split
                   0, KEY_W, 0,                                     // Triple
                   0, 0, 0 };                                       // Quad/Quint
byte Keys021[] = { 0, KEY_SPACE, KEY_1, KEY_2, KEY_3, KEY_EQUAL,    // Thumb + Single Key
                   0, KEY_HOME, KEY_END, 0,                         // Thumb + Double Pair
                   0, 0, 0,                                         // Thumb + Double Split
                   0, KEY_PAGE_DOWN, 0,                             // Thumb + Triple
                   0, 0, 0 };                                       // Thumb + Quad/Quint

byte Keys030[] = { 0, 0, KEY_Z, KEY_Q, KEY_X, 0,                    // Single Key
                   0, KEY_J, 0, 0,                                  // Double Pair
                   0, 0, 0,                                         // Double Split
                   0, 0, 0,                                         // Triple
                   0, 0, 0 };                                       // Quad/Quint
byte Keys031[] = { 0, 0, KEY_COMMA, KEY_0, KEY_PERIOD, 0,            // Thumb + Single Key
                   0, KEY_HOME, KEY_END, 0,                         // Thumb + Double Pair
                   0, 0, 0,                                         // Thumb + Double Split
                   0, KEY_PAGE_DOWN, 0,                             // Thumb + Triple
                   0, 0, 0 };                                       // Thumb + Quad/Quint

int  CurRow = 0;
int  CurKey = 0;
int  MaxKey = 0;
byte ModKey = 0;
byte Mapped = 0;
byte Send   = 0;

void setup() {
  pinMode( 0, INPUT_PULLUP);
  pinMode( 1, INPUT_PULLUP);
  pinMode( 2, INPUT_PULLUP);
  pinMode( 3, INPUT_PULLUP);
  pinMode( 4, OUTPUT);
  // 5 = SCL
  // 6 = SDA
  pinMode( 7, INPUT_PULLUP);
  pinMode( 8, INPUT_PULLUP);
  pinMode( 9, OUTPUT);
  pinMode(10, INPUT_PULLUP);
  pinMode(11, INPUT_PULLUP);  // Swap With 12
  pinMode(12, OUTPUT);        // Swap With 11
  pinMode(13, INPUT_PULLUP);
  pinMode(14, OUTPUT);
  pinMode(15, OUTPUT); 
  pinMode(16, INPUT_PULLUP);
  pinMode(17, INPUT_PULLUP);
  pinMode(18, INPUT_PULLUP);
  pinMode(19, INPUT_PULLUP);
  pinMode(20, INPUT_PULLUP);
  pinMode(21, INPUT_PULLUP);
  pinMode(22, INPUT_PULLUP);
  pinMode(23, INPUT_PULLUP);
  pinMode(24, INPUT_PULLUP);
  
//  Wire.begin();
}

void loop() {
  button00.update();
  button01.update();
  button02.update();
  button03.update();
  button04.update();
  button10.update();
  button11.update();
  button12.update();
  button13.update();
  button14.update();
  button20.update();
  button21.update();
  button22.update();
  button23.update();
  button24.update();
  button31.update();
  button32.update();
  button33.update();

// Key Press
  if (button00.fallingEdge()) { MaxKey |=  1; CurKey |=  1; CurRow = 1; }
  if (button01.fallingEdge()) { MaxKey |=  2; CurKey |=  2; CurRow = 1; }
  if (button02.fallingEdge()) { MaxKey |=  4; CurKey |=  4; CurRow = 1; }
  if (button03.fallingEdge()) { MaxKey |=  8; CurKey |=  8; CurRow = 1; }
  if (button04.fallingEdge()) { MaxKey |= 16; CurKey |= 16; CurRow = 1; }

  if (button10.fallingEdge()) { MaxKey |=  1; CurKey |=  1; CurRow = 2; }
  if (button11.fallingEdge()) { MaxKey |=  2; CurKey |=  2; CurRow = 2; }
  if (button12.fallingEdge()) { MaxKey |=  4; CurKey |=  4; CurRow = 2; }
  if (button13.fallingEdge()) { MaxKey |=  8; CurKey |=  8; CurRow = 2; }
  if (button14.fallingEdge()) { MaxKey |= 16; CurKey |= 16; CurRow = 2; }

  if (button20.fallingEdge()) { MaxKey |= 32; CurKey |= 32; };             // Thumb Key
  if (button21.fallingEdge()) { MaxKey |=  2; CurKey |=  2; CurRow = 3; }
  if (button22.fallingEdge()) { MaxKey |=  4; CurKey |=  4; CurRow = 3; }
  if (button23.fallingEdge()) { MaxKey |=  8; CurKey |=  8; CurRow = 3; }
  if (button24.fallingEdge()) { MaxKey |= 16; CurKey |= 16; CurRow = 3; }

  if (button31.fallingEdge()) { MaxKey |=  2; CurKey |=  2; CurRow = 4; }
  if (button32.fallingEdge()) { MaxKey |=  4; CurKey |=  4; CurRow = 4; }
  if (button33.fallingEdge()) { MaxKey |=  8; CurKey |=  8; CurRow = 4; }
  
// Key Release
  if (button00.risingEdge() || button10.risingEdge()) CurKey &= B11111110;  // 1
  if (button01.risingEdge() || button11.risingEdge() || button21.risingEdge() || button31.risingEdge()) CurKey &= B11111101;  // 2
  if (button02.risingEdge() || button12.risingEdge() || button22.risingEdge() || button32.risingEdge()) CurKey &= B11111011;  // 4
  if (button03.risingEdge() || button13.risingEdge() || button23.risingEdge() || button33.risingEdge()) CurKey &= B11110111;  // 8
  if (button04.risingEdge() || button14.risingEdge() || button24.risingEdge()) CurKey &= B11101111;  // 16
  if (button20.risingEdge()) CurKey &= B11011111;  // 32 (Thumb)

// Ouput As Needed
  if ((CurKey == 0) && (MaxKey > 0)) {
    Send = 0;
    Mapped = KeyMap[(CurKey & 31)];
    if (Mapped > 0) {
      if ((CurKey & 32) == 32) CurRow += 4;
      switch (CurRow) {
        case 1: Send = Keys000[Mapped]; break;
        case 2: Send = Keys010[Mapped]; break;
        case 3: Send = Keys020[Mapped]; break;
        case 4: Send = Keys030[Mapped]; break;
        case 5: Send = Keys001[Mapped]; break;
        case 6: Send = Keys011[Mapped]; break;
        case 7: Send = Keys021[Mapped]; break;
        case 8: Send = Keys031[Mapped]; break;
      }      
      
       if ((Send != 0) && (Send != 255)) {
         switch (Send) {
           case 253: ModKey = (ModKey == 2) ? 0 : 1; break;
           case 252: ModKey = (ModKey == 2) ? 0 : 2; break;
         }
         switch (ModKey) {
           case 0: Keyboard.set_modifier(0);
                   break;
           case 1: Keyboard.set_modifier(MODIFIERKEY_SHIFT);
                   ModKey = 0;
                   break;
           case 2: Keyboard.set_modifier(MODIFIERKEY_SHIFT);
                   break;
        }
        Keyboard.set_key1(Send);
        Keyboard.send_now();
        Keyboard.set_key1(0);  
        Keyboard.send_now();
      }
      CurRow = 0;
      MaxKey = 0;
    }
  }
}

