void loop() {
  // value = EEPROM.read(address);
  // EEPROM.write(address,value);
  
  //(B5)(B6)(D7)(B7)(C6)
  // F4  F1  F0  B0  B1
  // F5  F6  E6  D2  B2
  //[F7] B4  D4  C7 [B3]
  //[  ] D6  D5  D3 [  ]

  Now = millis();
  
  // Write Mode LEDs
  if  (Mode == 0) PORTB |= B00100000; else PORTB &= B11011111;
  if ((Mode == 1) || (Mode == 7)) PORTB |= B01000000; else PORTB &= B10111111;    
  if ((Mode == 2) || (Mode == 6)) PORTD |= B10000000; else PORTD &= B01111111;
  if ((Mode == 3) || (Mode == 5)) PORTB |= B10000000; else PORTB &= B01111111;
  if  (Mode == 4) PORTC |= B01000000; else PORTC &= B10111111;

  if (Mode < 4) { // Right Hand Mode
    // Read Input Pins
    Keys   =  (PINF & B10000000) ? 1 : 0;  // .0 
    Keys  |= ((PIND & B01000000) >> 5);    // .1
    nThumb =   Keys ^ B00000011;  // Invert Switches
    Keys   =  (PINF & B00010000);          // .4
    Keys  |= ((PINF & B00000011) << 2);    // .3 .2
    Keys  |= ((PINB & B00000001) << 1);    // .1
    Keys  |= ((PINB & B00000010) >> 1);    // .0
    Row[1] =   Keys ^ B00011111;
    Keys   = ((PINF & B00100000) >> 1);    // .4
    Keys  |= ((PINF & B01000000) >> 3);    // .3
    Keys  |= ((PINE & B01000000) >> 4);    // .2
    Keys  |= ((PIND & B00000100) >> 1);    // .1
    Keys  |= ((PINB & B00000100) >> 2);    // .0
    Row[2] =   Keys ^ B00011111;
    Keys   = ((PINB & B00010000) >> 1);    // .3
    Keys  |= ((PIND & B00010000) >> 2);    // .2
    Keys  |= ((PINC & B10000000) >> 6);    // .1
    Keys  |= ((PINB & B00001000) >> 3);    // .0
    Row[3] =   Keys ^ B00001111;
    Keys   = ((PIND & B00100000) >> 4);    // .1
    Keys  |= ((PIND & B00001000) >> 3);    // .0
    Row[4] =   Keys ^ B00000011;
  } else {   // Left Hand Mode
    // Read Input Pins
    // Thumb Buttons ===============================
    Keys   = ((PINB & B00001000) >> 3);    // .0
    Keys  |= ((PIND & B00001000) >> 2);    // .1
    nThumb =   Keys ^ B00000011;  // Invert Switches 
    // Top Row =====================================
    Keys   = ((PINF & B00010000) >> 4);    // .0
    Keys  |=  (PINF & B00000010);          // .1
    Keys  |= ((PINF & B00000001) << 2);    // .2
    Keys  |= ((PINB & B00000011) << 3);    // .3 .4
    Row[1] =   Keys ^ B00011111;  // Invert Switches    
    // Row 2 =======================================
    Keys   = ((PINF & B01100000) >> 5);    // .0 .1
    Keys  |= ((PINE & B01000000) >> 4);    // .2
    Keys  |= ((PIND & B00000100) << 1);    // .3
    Keys  |= ((PINB & B00000100) << 2);    // .4
    Row[2] =   Keys ^ B00011111;  // Invert Switches    
    // Row 3 =======================================
    Keys   = ((PINF & B10000000) >> 7);    // .0
    Keys  |= ((PINB & B00010000) >> 3);    // .1
    Keys  |= ((PIND & B00010000) >> 2);    // .2
    Keys  |= ((PINC & B10000000) >> 4);    // .3
    Row[3] =   Keys ^ B00001111;  // Invert Switches    
    // Row 4 =======================================
    Keys   = ((PIND & B01000000) >> 6);    // .0
    Keys  |= ((PIND & B00100000) >> 4);    // .1
    Row[4] =   Keys ^ B0000011;  // Invert Switches
  }
  iComboOld = iCombo;
  iLatchOld = iLatch;
  iCombo = (Row[1] | (Row[2] << 5) | (Row[3] << 10) | (Row[4] << 14));
  iLatch |= iCombo;
  
  if ((iLatch != iLatchOld) || (iCombo != iComboOld)) lBounce = Now; 
  if ((Now - lBounce) > 40) {
    if (iLatch != 0) {      
      if ((Step == 0) && (iLatch != 1024) && ((Mode != 0) || (iLatch != 16))) {
        iSeq[Step] = iLatch;
        iSendCode  = iLatch;
        Step++;
      } else if ((Step < 7) && (iLatch != iSeq[(Step - 1)])) {
        iSeq[Step] = iLatch;
        iSendCode  = (iLatch ^ iSeq[(Step-1)]);
        Step++;
      } else if (iCombo == 0) {
        if ((Step == 0) && ((iLatch == 1024) || ((Mode == 0) && (iLatch == 16)))) iSendCode = iLatch;
        iLatch = 0;
        Step   = 0;
      } else if ((Now - lBounce) > 750) {
        lBounce += 75;
        Repeated = true;
        iSendCode = iSeq[(Step-1)];
      }
    }
  }
  if (nThumb != 0) {
    if (nThumb != oThumb) lThumb = Now;
    if ((Now - lThumb) > 30) Thumb |= nThumb;
  }
  oThumb = nThumb;

  if (iSendCode > 0) {
    Send[1] = 0;
    Ptr  = 0;
    QuitLoop = false;
    while ((Send[1] == 0) && (QuitLoop == false)) {
      if (KeyCombo[Ptr] == 255) QuitLoop = true;
      else {
        iCode = KeyCombo[Ptr] | (KeyCombo[(Ptr + 3)] << 5) | (KeyCombo[(Ptr + 6)] << 10) | (KeyCombo[(Ptr + 9)] << 14);
        if (iSendCode == iCode) {
          Offset   = ((Thumb & 1) > 0) ? 2 : 1;
          if ((Mode > 0) && (Mode < 4)) Offset  += (Mode * 3);
          Send[1] = (Offset > 11) ? 0 : KeyCombo[(Ptr + Offset)];
          switch (Step) {
            case 2:
              switch ((char)Send[1]) {
                case (char)KEY_BACKSPACE: if (SendOld == 240) Send[1] = 244; break;  // Mirror
                case (char)KEY_I: if (SendOld == 240) Send[1] = 243; break;
                case (char)KEY_O: if (SendOld == 240) Send[1] = 242; break;                 
                case (char)KEY_E: if (SendOld == (char)KEY_T) Send[1] = KEY_H; break;
                case (char)KEY_A: switch (SendOld) {
                                    case 240:         Send[1] = 241;   break;
                                    case (char)KEY_O: Send[1] = KEY_F; break;
                                  }
                case (char)KEY_S: if (SendOld == (char)KEY_N) Send[1] = KEY_G; break;
              }
              break;
            case 3:
              switch ((char)Send[1]) {
                case (char)KEY_N: if (SendOld == (char)KEY_H) Send[1] = KEY_E; Send[2] = KEY_N; break;
              }
              break;              
          }          
          QuitLoop = true;
        } else Ptr += 12;
      }
    }
    iSendCode = 0;
  }
  
  if (nThumb == 0) {
     if (Send[0] == 0) {
      // +----------------------------------------------------------+  
      // | Generate characters for modifier keys when pressed alone |
      // +----------------------------------------------------------+
      switch (Thumb) {
        case 1: Send[1] = KEY_SPACE; break;
        case 2: Send[1] = 255; break;  // Shift
        case 3: Send[1] = 254; break;  // Shift Lock
      }
    }
    Send[0] = 0;
    Thumb = 0;
  }

  // +-------------------------------------------------------------+  
  // | Convert shifted keys code into base key plus shift modifier |
  // +-------------------------------------------------------------+
  if (Send[1] >= 240) {
    switch (Send[1]) {
      case 240: Mode = (Mode & 4); break;                    // Standard
      case 241: Mode = (Mode & 4) | 1; break;                // Number
      case 242: Mode = (Mode & 4) | 2; break;                // Cursor
      case 243: Mode = (Mode & 4) | 3; break;                // Function
      case 244: Mode ^= 4; break;                            // Switch Hand
      case 251: ModKey = (ModKey ^ 16); break;               // Win
      case 252: ModKey = (ModKey ^ 8); break;                // Alt
      case 253: ModKey = (ModKey ^ 4); break;                // Control
      case 254: ModKey = ((ModKey & 3) < 2) ? 2 : 0; break;  // Shift Lock
      case 255: ModKey = ((ModKey & 3) == 0) ? 1 : 0; break; // Shift
    }
    delay(20);
    Send[0] = Send[1];
    SendOld = Send[1];
    Send[1] = 0;
  }

#ifdef OLED
  if (Mode != oMode) {
    SeeedOled.setTextXY(0,0);            // Set the cursor to Xth Page, Yth Column  
    switch (Mode) {
      case 0: SeeedOled.putString("  RIGHT MODE   "); break;
      case 1: SeeedOled.putString("  Number Mode  "); break;
      case 2: SeeedOled.putString("  Cursor Mode  "); break;
      case 3: SeeedOled.putString(" Function Mode "); break;
      case 4: SeeedOled.putString("  LEFT  MODE   "); break;
      case 5: SeeedOled.putString("  Number Mode  "); break;
      case 6: SeeedOled.putString("  Cursor Mode  "); break;
      case 7: SeeedOled.putString(" Function Mode "); break;
    }
    oMode = Mode;
  }  
  if (oMod != ModKey) {
    SeeedOled.setTextXY(2,9); SeeedOled.putString((ModKey &  3) ? "ON " : "OFF");
    SeeedOled.setTextXY(3,9); SeeedOled.putString((ModKey &  4) ? "ON " : "OFF");
    SeeedOled.setTextXY(4,9); SeeedOled.putString((ModKey &  8) ? "ON " : "OFF");
    SeeedOled.setTextXY(5,9); SeeedOled.putString((ModKey & 16) ? "ON " : "OFF");
    oMod = ModKey;
  }
#endif

  // +-------------------------------------------------+  
  // | Send Characters to computer using USB functions |
  // +-------------------------------------------------+
  if (Send[1] > 0) {
    if (Send[1] < 240) {
      Mod[1]  = 0;
      if (ModKey > 0) {
        if ((ModKey &  3) > 0) Mod[1]  = MODIFIERKEY_SHIFT;
        if ((ModKey &  4) > 0) Mod[1] |= MODIFIERKEY_CTRL;
        if ((ModKey &  8) > 0) Mod[1] |= MODIFIERKEY_ALT;
        if ((ModKey & 16) > 0) Mod[1] |= MODIFIERKEY_GUI;
        ModKey &= B11100010;  // Use up non-latched shift, ctrl & alt      
      }
      if ((Send[1] > 0xA5) && (Send[1] < 0xDF)) {
        switch ((char)Send[1]) {
          case SK_LBRKT:  Send[1] = KEY_9;           Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_0;           Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          case SK_LCBRKT: Send[1] = KEY_LEFT_BRACE;  Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_RIGHT_BRACE; Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          default:        Send[1] -= 0x90;           Mod[1] = MODIFIERKEY_SHIFT;
                          break;
        }
      } else {
        switch (Send[1]) {
          case (char)KEY_LEFT_BRACE:
                          Send[1] = KEY_LEFT_BRACE;  Mod[1] = 0;
                          Send[2] = KEY_RIGHT_BRACE; Mod[2] = 0;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
        }
      }
      if ((Thumb & 2) && (Mod[1] == 0)) Mod[1] = MODIFIERKEY_SHIFT;
      Keyboard.set_modifier(Mod[1]);
      Keyboard.set_key1(Send[1]);
      Keyboard.send_now();
      Send[0] = Send[1];
      SendOld = Send[1];
      Send[1] = 0;
      if (Send[2] != 0) {
        if ((Thumb & 2) && (Mod[2] == 0)) Mod[2] = MODIFIERKEY_SHIFT;
        Keyboard.set_modifier(Mod[2]);
        Keyboard.set_key1(Send[2]);
        Keyboard.send_now();
        Send[2] = 0;
        Mod[2]  = 0;
      }
      if (Send[3] != 0) {
        // Send the cursor left with no modifier
        if ((Thumb & 2) && (Mod[3] == 0)) Mod[3] = MODIFIERKEY_SHIFT;
        Keyboard.set_modifier(Mod[3]);
        Keyboard.set_key1(Send[3]);
        Keyboard.send_now();
        Send[3] = 0;
        Mod[3]  = 0;
      }
      Keyboard.set_modifier(0);
      Keyboard.set_key1(0);
      Keyboard.send_now();
    }
  }
}

