// OneHand V0.5
#define OLED
#ifdef OLED
  #include <Wire.h>
  #include <SeeedOLED.h>
#endif

//#include <EEPROM.h>

#include "K5_xxxxx.h"

byte  Row[]    = { 0, 0, 0, 0, 0 };

byte  i;
byte  Keys;
byte  Send[4]  = {0, 0, 0, 0};
byte  Mod[4]   = {0, 0, 0, 0};
byte  SendOld  = 0;

byte  nThumb   = 0;
byte  Thumb    = 0;
byte  oThumb   = 0;
long  lThumb   = 0;

byte  ModKey   = 0;
byte  oMod     = 0;
int   Ptr      = 0;
byte  QuitLoop = false;
byte  Offset   = 0;
byte  Mode     = 0;
byte  oMode    = 0;
byte  OldMode  = 0;
byte  Mirror   = 0;
byte  Modifier = 0;
byte  Step     = 0;
byte  Repeated = false;

unsigned int iCombo    = 0;
unsigned int iComboOld = 0;
unsigned int iLatch    = 0;
unsigned int iLatchOld = 0;
unsigned int iSeq[8]   = { 0, 0, 0, 0, 0, 0, 0, 0 };
unsigned int iSendCode = 0;
unsigned int iCode     = 0;

long  Now;
long  lBounce;
long  keydelay;

// == Modified Keys - Generates Shift + Another key to generate
#define SK_EXCLAMATION (0x90 + KEY_1)
#define SK_AT          (0x90 + KEY_2)
#define SK_HASH        (0x90 + KEY_3)
#define SK_DOLLAR      (0x90 + KEY_4)
#define SK_PERCENT     (0x90 + KEY_5)
#define SK_CAROT       (0x90 + KEY_6)
#define SK_AMP         (0x90 + KEY_7)
#define SK_STAR        (0x90 + KEY_8)
#define SK_LBRKT       (0x90 + KEY_9)
#define SK_RBRKT       (0x90 + KEY_0)
#define SK_Underline   (0x90 + KEY_MINUS)
#define SK_LCBRKT      (0x90 + KEY_LEFT_BRACE)
#define SK_RCBRKT      (0x90 + KEY_RIGHT_BRACE)
#define SK_QMARK       (0x90 + KEY_SLASH)
#define SK_BAR         (0x90 + KEY_BACKSLASH)
#define SK_LESS        (0x90 + KEY_COMMA) 
#define SK_GRTR        (0x90 + KEY_PERIOD)
#define SK_DQUOTE      (0x90 + KEY_QUOTE)
#define SK_COLON       (0x90 + KEY_SEMICOLON)

// ====== Cursor Keys ======
// UP, DOWN, LEFT, RIGHT, HOME, END, PAGE UP, PAGE DOWN, TAB
// ====== Normal Keys ======
// Letters: KEY_A  .. KEY_Z
// Numbers: KEY_0  .. KEY_9
// FN Keys: KEY_F1 .. KEY_F12
// KEYPAD_0 .. KEYPAD_9
// KEY_ENTER	    KEY_ESC	    KEY_BACKSPACE   KEY_TAB
// KEY_SPACE	    KEY_MINUS	    KEY_EQUAL	    KEY_LEFT_BRACE
// KEY_RIGHT_BRACE  KEY_BACKSLASH   KEY_NUMBER	    KEY_SEMICOLON
// KEY_QUOTE	    KEY_TILDE       KEY_COMMA	    KEY_PERIOD
// KEY_SLASH	    KEY_CAPS_LOCK   KEY_PRINTSCREEN KEY_SCROLL_LOCK
// KEY_PAUSE	    KEY_INSERT	    KEY_HOME	    KEY_PAGE_UP
// KEY_DELETE	    KEY_END	    KEY_PAGE_DOWN   KEY_RIGHT
// KEY_LEFT	    KEY_DOWN	    KEY_UP	    KEY_NUM_LOCK
// KEYPAD_SLASH	    KEYPAD_ASTERIX  KEYPAD_MINUS    KEYPAD_PLUS
// KEYPAD_ENTER     KEYPAD_PERIOD

static const byte KeyCombo[] = {
  // *** Single Button Press ***
  K5_10000,   KEY_U,         KEY_ESC,        // [MODE]
  K5_00000,   240,           0,              // Mode 1  
  K4__0000,   240,           0,              // Mode 2
  K2___00_,   240,           0,              // Mode 3  
  //--------------------------------------------------
  K5_01000,   KEY_A,         KEY_7,          // [T]
  K5_00000,   KEY_7,         0,              // Mode 1  
  K4__0000,   KEY_PAGE_UP,   0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00100,   KEY_O,         KEY_8,          // [O]
  K5_00000,   KEY_8,         0,              // Mode 1  
  K4__0000,   KEY_UP,        0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00010,   KEY_I,         KEY_9,          // [I]
  K5_00000,   KEY_9,         0,              // Mode 1  
  K4__0000,   KEY_PAGE_DOWN, 0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00001,   KEY_BACKSPACE, KEY_DELETE,     // [Backspace]
  K5_00000,   KEY_BACKSPACE, KEY_DELETE,     // Mode 1  
  K4__0000,   KEY_BACKSPACE, KEY_DELETE,     // Mode 2  
  K2___00_,   KEY_BACKSPACE, KEY_DELETE,     // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_H,         KEY_0,          // [Shift]   
  K5_10000,   KEY_0,         0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_T,         KEY_4,          // [A]     
  K5_01000,   KEY_4,         0,              // Mode 1                
  K4__0000,   KEY_LEFT,      0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_E,         KEY_5,          // [E]    
  K5_00100,   KEY_5,         0,              // Mode 1              
  K4__0000,   KEY_DOWN,      0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_N,         KEY_6,          // [N]     
  K5_00010,   KEY_6,         0,              // Mode 1              
  K4__0000,   KEY_RIGHT,     0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_S,         KEY_EQUAL,      // [S]           
  K5_00001,   KEYPAD_PLUS,   KEYPAD_ASTERIX, // Mode 1              
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_D,         KEY_1,          // [D]     
  K5_00000,   KEY_1,         0,              // Mode 1              
  K4__1000,   KEY_HOME,      0,              // Mode 2  
  K2___00_,   KEY_F1,        0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_R,         KEY_2,          // [R]     
  K5_00000,   KEY_2,         0,              // Mode 1              
  K4__0100,   KEY_F2,        0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_L,         KEY_3,          // [B]     
  K5_00000,   KEY_3,         0,              // Mode 1           
  K4__0010,   KEY_END,       0,              // Mode 2  
  K2___00_,   KEY_F3,        0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_ENTER,     0,              // [ENTER]
  K5_00000,   0,             0,              // Mode 1           
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_COMMA,     253,            // [C]          
  K5_00000,   KEY_PERIOD,    0,              // Mode 1              
  K4__0000,   0,             0,              // Mode 2  
  K2___10_,   KEY_F11,       0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_PERIOD,    252,            // [.]         
  K5_00000,   KEY_EQUAL,     0,              // Mode 1
  K4__0000,   0,             0,              // Mode 2  
  K2___01_,   KEY_F12,       0,              // Mode 3  
  //--------------------------------------------------
  // *** Double Button Press ***
  K5_11000,   241,           KEY_TAB,        // [MODE] + [T]
  K5_00000,   241,           0,              // Mode 1  
  K4__0000,   241,           0,              // Mode 2
  K2___00_,   241,           0,              // Mode 3  
  //--------------------------------------------------
  K5_01100,   KEY_F,         KEY_UP,         // [T] + [O]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2      
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00110,   KEY_Y,         KEY_DOWN,       // [O] + [I]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3
  //--------------------------------------------------
  K5_00011,   KEY_Q,         0,              // [I] + [Backspace]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_C,         KEY_HOME,       // [Shift] + [A]
  K5_11000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_P,         KEY_LEFT,       // [A] + [E]
  K5_01100,   KEYPAD_MINUS,  0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_M,         KEY_RIGHT,      // [E] + [N]
  K5_00110,   KEYPAD_PLUS,   0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_G,         KEY_END,        // [N] + [S]
  K5_00011,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_B,         KEYPAD_MINUS,   // [D] + [R]
  K5_00000,   KEY_SLASH,     0,              // Mode 1  
  K4__1100,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_V,         KEYPAD_PLUS,    // [R] + [B]
  K5_00000,   SK_STAR,       0,              // Mode 1  
  K4__0110,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_QUOTE,     252,              // [C] + [.]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___11_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // ** Diagonal Doubles **
  //--------------------------------------------------
  K5_00100,   KEY_SLASH,     SK_LESS,        // [O] + [A]
  K5_01000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00100,   KEY_BACKSLASH, SK_GRTR,        // [O] + [N]
  K5_00010,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [O] + [A]
  K5_00100,   0,             0,              // Mode 1  
  K4__1000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [O] + [A]
  K5_00100,   0,             0,              // Mode 1  
  K4__0010,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
 //--------------------------------------------------
  K5_00000,   SK_LESS,       KEY_SLASH,      // [O] + [A]
  K5_10000,   0,             0,              // Mode 1  
  K4__1000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_GRTR,       KEYPAD_ASTERIX, // [O] + [A]
  K5_00001,   0,             0,              // Mode 1  
  K4__0010,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // ** Double Vertical **                         
  K5_10000,   KEY_LEFT_BRACE,0,              // [T] + [A]
  K5_10000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_01000,   SK_LBRKT,      0,              // [MODE] + [SHIFT]
  K5_01000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00100,   SK_EXCLAMATION, 0,             // [O] + [E]
  K5_00100,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00010,   SK_RBRKT,      0,              // [BACKSPACE] + [S]
  K5_00010,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00001,   KEY_RIGHT_BRACE, 0,              // [I] + [N]
  K5_00001,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_LCBRKT,     0,              // [BACKSPACE] + [S]
  K5_01000,   0,             0,              // Mode 1
  K4__1000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_BAR,        0,             // [BACKSPACE] + [S]
  K5_00100,   0,             0,              // Mode 1  
  K4__0100,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_RCBRKT,     0,              // [BACKSPACE] + [S]
  K5_00010,   0,             0,              // Mode 1  
  K4__0010,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_AT,         0,             // [BACKSPACE] + [S]
  K5_00000,   0,             0,              // Mode 1  
  K4__1000,   0,             0,              // Mode 2  
  K2___10_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_SEMICOLON, 0,              // [BACKSPACE] + [S]
  K5_00000,   0,             0,              // Mode 1  
  K4__0100,   0,             0,              // Mode 2  
  K2___10_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_COLON,      0,              // [BACKSPACE] + [S]
  K5_00000,   0,             0,              // Mode 1  
  K4__0010,   0,             0,              // Mode 2  
  K2___01_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // *** Split Double Button Press ***
  K5_10100,   242,           0,              // [MODE] + [I]
  K5_00000,   242,           0,              // Mode 1  
  K4__0000,   242,           0,              // Mode 2  
  K2___00_,   242,           0,              // Mode 3  
  //--------------------------------------------------
  K5_01010,   KEY_P,         0,              // [T] + [L]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00101,   0,             0,              // [I] + [Backspace]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [Shift] + [A]
  K5_10100,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_W,         0,              // [E] + [S]
  K5_01010,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [A] + [.]   
  K5_00101,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  de
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_C,         SK_STAR,        // [O] + [C]
  K5_00000,   0,             0,              // Mode 1  
  K4__1010,   0,             0,              // Mode 2 
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             251,        // [O] + [C]
  K5_00000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2 
  K2___10_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // *** Triple Button Press ***
  //--------------------------------------------------
  K5_11100,   KEY_Z,         0,              // [MODE] + [T] + [O]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_01110,   KEY_J,         KEY_PAGE_UP,    // [T] + [O] + [I]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00111,   0,             0,              // [O] + [I] + [Backspace]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_X,         0,              // [Shift] + [A] + [E]
  K5_11100,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_W,         0,              // [A] + [E] + [N]
  K5_01110,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3 
  //--------------------------------------------------
  K5_00000,   SK_QMARK,      0,              // [E] + [N] + [S]
  K5_00111,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_K,         0,              // [D] + [R] + [B]
  K5_00000,   0,             0,              // Mode 1  
  K4__1110,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00100,   SK_CAROT,      0,              // [U] + [C] + [.]
  K5_01010,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // *** Quadruple Button Press ***
  K5_11110,   0,             0,              // [MODE] + [T] + [I] + [L]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_01111,   0,             0,              // [T] + [I] + [L] + [Backspace]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [Shift] + [E] + [A] + [S]
  K5_11110,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_BACKSPACE, 0,              // [E] + [A] + [S] + [.]
  K5_01111,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // *** Quintuple Button Press ***
  K5_11111,   0,             0,              // [MODE] + [T] + [I] + [L] + [Backspace]
  K5_00000,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_ESC,       0,              // [Shift] + [E] + [A] + [S] + [.]
  K5_11111,   0,             0,              // Mode 1  
  K4__0000,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_10010,   243,           0,              // [MODE] + [L]
  K5_00000,   243,           0,              // Mode 1  
  K4__0000,   243,           0,              // Mode 2
  K2___00_,   243,           0,              // Mode 3  
  //--------------------------------------------------
  K5_10001,   244,           0,              // [MODE] + [BS]
  K5_00000,   244,           0,              // Mode 1  
  K4__0000,   244,           0,              // Mode 2
  K2___00_,   244,           0,              // Mode 3  
  // ============== Special Symbols ==================
  K5_01000,   SK_AT,         0,              // [ENTER] + [A]
  K5_00000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00100,   0,             0,              // [ENTER] + [O]
  K5_00000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00010,   0,             0,              // [ENTER] + [I]
  K5_00000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_HASH,       0,              // [ENTER] + [H]
  K5_10000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [T]
  K5_01000,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [E]
  K5_00100,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [N]
  K5_00010,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   SK_DOLLAR,     0,              // [ENTER] + [S]
  K5_00001,   0,             0,              // Mode 1  
  K4__0001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [D]
  K5_00000,   0,             0,              // Mode 1  
  K4__1001,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [R]
  K5_00000,   0,             0,              // Mode 1  
  K4__0101,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  K5_00000,   0,             0,              // [ENTER] + [L]
  K5_00000,   0,             0,              // Mode 1  
  K4__0011,   0,             0,              // Mode 2  
  K2___00_,   0,             0,              // Mode 3  
  //--------------------------------------------------
  // END MARKER --------------------------------------
  255 }; // END MARKER
  //===================================================
  
