void loop() {
  // value = EEPROM.read(address);
  // EEPROM.write(address,value);

  //(B5)(B6)(D7)(B7)(C6)
  // F4  F1  F0  B0  B1
  // F5  F6  E6  D2  B2
  //[F7] B4  D4  C7 [B3]
  //[  ] D6  D5  D3 [  ]

  Now = millis();

  // Write Mode LEDs
  if  (Mode == 0) PORTB |= B00100000; else PORTB &= B11011111;
  if ((Mode == 1) || (Mode == 7)) PORTB |= B01000000; else PORTB &= B10111111;    
  if ((Mode == 2) || (Mode == 6)) PORTD |= B10000000; else PORTD &= B01111111;
  if ((Mode == 3) || (Mode == 5)) PORTB |= B10000000; else PORTB &= B01111111;
  if  (Mode == 4) PORTC |= B01000000; else PORTC &= B10111111;

  iComboOld  = iCombo;
  iModOld    = iModKeys;
  iCombo     = 0;
  iModKeys   = 0;
  if (Mode < 4) { // Right Hand Mode
    // Top Row =====================================
    if ((PINB & B00000010) == 0) iCombo |= 0x0001;
    if ((PINB & B00000001) == 0) iCombo |= 0x0002;
    if ((PINF & B00000001) == 0) iCombo |= 0x0004;
    if ((PINF & B00000010) == 0) iCombo |= 0x0008;
    if ((PINF & B00010000) == 0) iCombo |= 0x0010;
    // Row 2 =======================================
    if ((PINB & B00000100) == 0) iCombo |= 0x0020;
    if ((PIND & B00000100) == 0) iCombo |= 0x0040;
    if ((PINE & B01000000) == 0) iCombo |= 0x0080;
    if ((PINF & B01000000) == 0) iCombo |= 0x0100;
    if ((PINF & B00100000) == 0) iCombo |= 0x0200;
    // Row 3 =======================================
    if ((PINC & B10000000) == 0) iCombo |= 0x0400;
    if ((PIND & B00010000) == 0) iCombo |= 0x0800;
    if ((PINB & B00010000) == 0) iCombo |= 0x1000;
    // Row 4 =======================================
    if ((PINB & B00001000) == 0) iCombo |= 0x2000;
    if ((PIND & B00001000) == 0) iCombo |= 0x4000;
    if ((PIND & B00100000) == 0) iCombo |= 0x8000;
    // Row 4 Modifiers =============================
    if ((PIND & B01000000) == 0) iModKeys |= 0x01;
    if ((PINF & B10000000) == 0) iModKeys |= 0x02;
  } else {   // Left Hand Mode
    // Top Row =====================================
    if ((PINF & B00010000) == 0) iCombo |= 0x0001;
    if ((PINF & B00000010) == 0) iCombo |= 0x0002;
    if ((PINF & B00000001) == 0) iCombo |= 0x0004;
    if ((PINB & B00000001) == 0) iCombo |= 0x0008;
    if ((PINB & B00000010) == 0) iCombo |= 0x0010;
    // Row 2 =======================================
    if ((PINF & B00100000) == 0) iCombo |= 0x0020;
    if ((PINF & B01000000) == 0) iCombo |= 0x0040;
    if ((PINE & B01000000) == 0) iCombo |= 0x0080;
    if ((PIND & B00000100) == 0) iCombo |= 0x0100;
    if ((PINB & B00000100) == 0) iCombo |= 0x0200;
    // Row 3 =======================================
    if ((PINB & B00010000) == 0) iCombo |= 0x0400;
    if ((PIND & B00010000) == 0) iCombo |= 0x0800;
    if ((PINC & B10000000) == 0) iCombo |= 0x1000;
    // Row 4 =======================================
    if ((PINF & B10000000) == 0) iCombo |= 0x2000;
    if ((PIND & B01000000) == 0) iCombo |= 0x4000;
    if ((PIND & B00100000) == 0) iCombo |= 0x8000;
    // Row 4 Modifiers =============================
    if ((PIND & B00001000) == 0) iModKeys |= 0x1;
    if ((PINB & B00001000) == 0) iModKeys |= 0x2;
  }  
  iLatchOld   = iLatch;
  iModLtchOld = iModLatch;
  iLatch     |= iCombo;
  iModLatch  |= iModKeys;

  // Debounce Key Presses
  if ( (iLatch != iLatchOld) || (iModLatch != iModLtchOld) || (iCombo != iComboOld) || (iModKeys  != iModOld) ) lBounce = Now; 

  if ((Now - lBounce) > 40) {
    if ((iModKeys > 0) && (iCombo == 0) && (Step == 0)) bModOnly = true;  // Rising Edge Of Modifier...
    if (iCombo > 0) bModOnly = false;
    if (iLatch != 0) {
      if ((Step == 0) && (iLatch != 0)) {
        iSeq[Step]    = iLatch;
        iSendCode     = iLatch;
        iModSeq[Step] = iModKeys;
        iSendMod      = iModKeys;
        Step++;
      } 
      else if ((Step < 7) && (iLatch != iSeq[(Step - 1)])) {
        iSeq[Step]    = iLatch;
        iModSeq[Step] = iModKeys;
        iSendCode     = (iLatch ^ iSeq[(Step-1)]);
        iSendMod      = iModKeys;
        Step++;
      } 
      else if ((iCombo == 0) && (iModKeys == 0)) {
        iLatch    = 0;
        iModLatch = 0;
        Step      = 0;
      } 
      else if ( ((Now - lBounce) > 750) && (iLatch != 0) ) {
        lBounce  += 75;
        Repeated  = true;
        iSendCode = iSeq[(Step - 1)];
        iSendMod  = iModSeq[(Step - 1)];
      }
    } else if (iModKeys == 0) {
      if (bModOnly) {
        iSendCode = 0;
        iSendMod  = iModLatch;
        iModLatch = 0;
        bModOnly  = false;
        Serial.println(iSendMod);
      }
      iModLatch = 0;
    }
  }

  if ((iSendCode != 0) || (iSendMod != 0)) {
    Send[1]  = 0;    
    Ptr      = 0;
    Serial.print(iSendCode);
    Serial.print("+");
    Serial.println(iSendMod);
    QuitLoop = false;
    while ((Send[1] == 0) && (QuitLoop == false)) {
      if (KeyCombo[Ptr] == 255) QuitLoop = true; 
      else {
        iCode    =  KeyCombo[Ptr];
        iCode   +=  KeyCombo[(Ptr + 2)] * 32;
        iCode   +=  KeyCombo[(Ptr + 4)] * 1024;
        iCode   += (KeyCombo[(Ptr + 6)] & 7) * 8192;
        if ((iSendCode == iCode) || (iSendCode == 0)) { // Main Keys Match...        
          iCodeMod = (KeyCombo[(Ptr + 6)] >> 3);         
          if ((iModKeys & 1) == 1) iCodeMod |= 1; // Add Shift Into Code
          if (iSendMod == iCodeMod) {
            Offset = 1;
            if ((Mode > 0) && (Mode < 4)) Offset |= (Mode * 2);
            Send[1] = (Offset > 7) ? 0 : KeyCombo[(Ptr + Offset)];
            if ((iSendMod & 1) == 1) ModKey = (ModKey & B11111100) + 1; // Force Shift Mode
            switch (Step) {
            case 2:
              switch ((char)Send[1]) {
                case (char)KEY_BACKSPACE: if (SendOld == 240) Send[1] = 244; break;  // Mirror
                case (char)KEY_I:         if (SendOld == 240) Send[1] = 243; break;
                case (char)KEY_O:         if (SendOld == 240) Send[1] = 242; break;                 
                case (char)KEY_E:         if (SendOld == (char)KEY_T) Send[1] = KEY_H; break;
                case (char)KEY_A:         switch (SendOld) {
                                            case 240: Send[1] = 241; break;
                                            case (char)KEY_O: Send[1] = KEY_F; break;
                                          }
                                          break;
                case (char)KEY_S:         if (SendOld == (char)KEY_N) Send[1] = KEY_G; break;
              }
              break;
            case 3:
              switch ((char)Send[1]) {
                case (char)KEY_N: if (SendOld == (char)KEY_H) Send[1] = KEY_E; Send[2] = KEY_N; break;
              }
              break;              
            }          
            QuitLoop = true;
          }
        } 
        Ptr += 8;
      }
    }
  }
  iSendCode = 0;
  iSendMod  = 0;

  // +-------------------------------------------------------------+  
  // | Convert shifted keys code into base key plus shift modifier |
  // +-------------------------------------------------------------+
  if (Send[1] >= 240) {
    switch (Send[1]) {
      case 240: Mode = (Mode & 4); break;                    // Standard
      case 241: Mode = (Mode & 4) | 1; break;                // Number
      case 242: Mode = (Mode & 4) | 2; break;                // Cursor
      case 243: Mode = (Mode & 4) | 3; break;                // Function
      case 244: Mode ^= 4; break;                            // Switch Hand
      case 251: ModKey = (ModKey ^ 16); break;               // Win
      case 252: ModKey = (ModKey ^ 8); break;                // Alt
      case 253: ModKey = (ModKey ^ 4); break;                // Control
      case 254: ModKey = ((ModKey & 3) < 2) ? 2 : 0; break;  // Shift Lock
      case 255: ModKey = ((ModKey & 3) == 0) ? 1 : 0; break; // Shift
    }
    delay(20);
    Send[0] = Send[1];
    SendOld = Send[1];
    Send[1] = 0;
  }

#ifdef OLED
  if (Mode != oMode) {
    SeeedOled.setTextXY(0,0);            // Set the cursor to Xth Page, Yth Column  
    switch (Mode) {
      case 0: SeeedOled.putString("  RIGHT MODE   "); break;
      case 1: SeeedOled.putString("  Number Mode  "); break;
      case 2: SeeedOled.putString("  Cursor Mode  "); break;
      case 3: SeeedOled.putString(" Function Mode "); break;
      case 4: SeeedOled.putString("  LEFT  MODE   "); break;
      case 5: SeeedOled.putString("  Number Mode  "); break;
      case 6: SeeedOled.putString("  Cursor Mode  "); break;
      case 7: SeeedOled.putString(" Function Mode "); break;
    }
    oMode = Mode;
  }  
  if (oMod != ModKey) {
    SeeedOled.setTextXY(2,9); SeeedOled.putString((ModKey &  3) ? "ON " : "OFF");
    SeeedOled.setTextXY(3,9); SeeedOled.putString((ModKey &  4) ? "ON " : "OFF");
    SeeedOled.setTextXY(4,9); SeeedOled.putString((ModKey &  8) ? "ON " : "OFF");
    SeeedOled.setTextXY(5,9); SeeedOled.putString((ModKey & 16) ? "ON " : "OFF");
    oMod = ModKey;
  }
#endif

  // +-------------------------------------------------+  
  // | Send Characters to computer using USB functions |
  // +-------------------------------------------------+
  if (Send[1] > 0) {
    if (Send[1] < 240) {
      Mod[1]  = 0;
      if (ModKey > 0) {
        if ((ModKey &  3) > 0) Mod[1]  = MODIFIERKEY_SHIFT;
        if ((ModKey &  4) > 0) Mod[1] |= MODIFIERKEY_CTRL;
        if ((ModKey &  8) > 0) Mod[1] |= MODIFIERKEY_ALT;
        if ((ModKey & 16) > 0) Mod[1] |= MODIFIERKEY_GUI;
        ModKey &= B11100010;  // Use up non-latched shift, ctrl & alt      
      }
      if ((Send[1] > 0xA5) && (Send[1] < 0xDF)) {
        switch ((char)Send[1]) {
          case SK_LBRKT:  Send[1] = KEY_9;           Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_0;           Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          case SK_LCBRKT: Send[1] = KEY_LEFT_BRACE;  Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_RIGHT_BRACE; Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          default:        Send[1] -= 0x90;           Mod[1] = MODIFIERKEY_SHIFT;
                          break;
        }
      } 
      else {
        switch (Send[1]) {
          case (char)KEY_LEFT_BRACE: Send[1] = KEY_LEFT_BRACE;  Mod[1] = 0;
                                     Send[2] = KEY_RIGHT_BRACE; Mod[2] = 0;
                                     Send[3] = KEY_LEFT;        Mod[3] = 0;
                                     break;
        }
      }
      if ((Thumb & 2) && (Mod[1] == 0)) Mod[1] = MODIFIERKEY_SHIFT;
      Keyboard.set_modifier(Mod[1]);
      Keyboard.set_key1(Send[1]);
      Keyboard.send_now();
      Send[0] = Send[1];
      SendOld = Send[1];
      Send[1] = 0;
      if (Send[2] != 0) {
        if ((Thumb & 2) && (Mod[2] == 0)) Mod[2] = MODIFIERKEY_SHIFT;
        Keyboard.set_modifier(Mod[2]);
        Keyboard.set_key1(Send[2]);
        Keyboard.send_now();
        Send[2] = 0;
        Mod[2]  = 0;
      }
      if (Send[3] != 0) {
        // Send the cursor left with no modifier
        if ((Thumb & 2) && (Mod[3] == 0)) Mod[3] = MODIFIERKEY_SHIFT;
        Keyboard.set_modifier(Mod[3]);
        Keyboard.set_key1(Send[3]);
        Keyboard.send_now();
        Send[3] = 0;
        Mod[3]  = 0;
      }
      Keyboard.set_modifier(0);
      Keyboard.set_key1(0);
      Keyboard.send_now();
    }
  }
}

