// OneHand V0.5
//#define OLED
#ifdef OLED
  #include <Wire.h>
  #include <SeeedOLED.h>
#endif

//#include <EEPROM.h>

#include "K5_xxxxx.h"

byte  Row[]    = { 0, 0, 0, 0, 0 };

byte  i;
byte  Keys;
byte  Send[4]  = {0, 0, 0, 0};
byte  Mod[4]   = {0, 0, 0, 0};
byte  SendOld  = 0;

byte  bThumb = 0;
byte  bShift = 0;

byte  nThumb   = 0;
byte  Thumb    = 0;
byte  oThumb   = 0;
long  lThumb   = 0;

byte  ModKey   = 0;
byte  oMod     = 0;
int   Ptr      = 0;
byte  QuitLoop = false;
byte  Offset   = 0;
byte  Mode     = 0;
byte  oMode    = 0;
byte  OldMode  = 0;
byte  Mirror   = 0;
byte  Modifier = 0;
byte  Step     = 0;
byte  Repeated = false;

unsigned int iCombo    = 0;
unsigned int iComboOld = 0;
unsigned int iLatch    = 0;
unsigned int iLatchOld = 0;
unsigned int iSeq[8]   = { 0, 0, 0, 0, 0, 0, 0, 0 };
unsigned int iSendCode = 0;
unsigned int iCode     = 0;

byte iModKeys    = 0;
byte iModOld     = 0;
byte iModLatch   = 0;
byte iModLtchOld = 0;
byte iSendMod    = 0;
byte iModSeq[8]  = { 0, 0, 0, 0, 0, 0, 0, 0 };
byte iCodeMod    = 0;
byte bModOnly    = false;

long  Now;
long  lBounce;
long  keydelay;

// == Modified Keys - Generates Shift + Another key to generate
#define SK_EXCLAMATION (0x90 + KEY_1)
#define SK_AT          (0x90 + KEY_2)
#define SK_HASH        (0x90 + KEY_3)
#define SK_DOLLAR      (0x90 + KEY_4)
#define SK_PERCENT     (0x90 + KEY_5)
#define SK_CAROT       (0x90 + KEY_6)
#define SK_AMP         (0x90 + KEY_7)
#define SK_STAR        (0x90 + KEY_8)
#define SK_LBRKT       (0x90 + KEY_9)
#define SK_RBRKT       (0x90 + KEY_0)
#define SK_Underline   (0x90 + KEY_MINUS)
#define SK_LCBRKT      (0x90 + KEY_LEFT_BRACE)
#define SK_RCBRKT      (0x90 + KEY_RIGHT_BRACE)
#define SK_QMARK       (0x90 + KEY_SLASH)
#define SK_BAR         (0x90 + KEY_BACKSLASH)
#define SK_LESS        (0x90 + KEY_COMMA) 
#define SK_GRTR        (0x90 + KEY_PERIOD)
#define SK_DQUOTE      (0x90 + KEY_QUOTE)
#define SK_COLON       (0x90 + KEY_SEMICOLON)

// ====== Cursor Keys ======
// UP, DOWN, LEFT, RIGHT, HOME, END, PAGE UP, PAGE DOWN, TAB
// ====== Normal Keys ======
// Letters: KEY_A  .. KEY_Z
// Numbers: KEY_0  .. KEY_9
// FN Keys: KEY_F1 .. KEY_F12
// KEYPAD_0 .. KEYPAD_9
// KEY_ENTER	    KEY_ESC	    KEY_BACKSPACE   KEY_TAB
// KEY_SPACE	    KEY_MINUS	    KEY_EQUAL	    KEY_LEFT_BRACE
// KEY_RIGHT_BRACE  KEY_BACKSLASH   KEY_NUMBER	    KEY_SEMICOLON
// KEY_QUOTE	    KEY_TILDE       KEY_COMMA	    KEY_PERIOD
// KEY_SLASH	    KEY_CAPS_LOCK   KEY_PRINTSCREEN KEY_SCROLL_LOCK
// KEY_PAUSE	    KEY_INSERT	    KEY_HOME	    KEY_PAGE_UP
// KEY_DELETE	    KEY_END	    KEY_PAGE_DOWN   KEY_RIGHT
// KEY_LEFT	    KEY_DOWN	    KEY_UP	    KEY_NUM_LOCK
// KEYPAD_SLASH	    KEYPAD_ASTERIX  KEYPAD_MINUS    KEYPAD_PLUS
// KEYPAD_ENTER     KEYPAD_PERIOD

static const byte KeyCombo[] = {
  // *** Single Button Press ***
  K5_00000,   KEY_SPACE,     // [SPACE]
  K5_00000,   KEY_SPACE,     // Mode 1  
  K3__000_,   KEY_SPACE,     // Mode 2
  K5_10000,   KEY_SPACE,     // Mode 3  
  //--------------------------------------------------
  K5_10000,   KEY_U,         // [U]
  K5_00000,   240,           // Mode 1  
  K3__000_,   240,           // Mode 2
  K5_00000,   240,           // Mode 3  
  //--------------------------------------------------
  K5_10000,   KEY_ESC,       // [SPACE]+[U]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_01000,   KEY_A,         // [A]
  K5_00000,   KEY_7,         // Mode 1  
  K3__000_,   KEY_PAGE_UP,   // Mode 2  
  K5_00000,   KEY_F1,        // Mode 3  
  //--------------------------------------------------
  K5_01000,   KEY_F,         // [SPACE]+[A]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00100,   KEY_O,         // [O]
  K5_00000,   KEY_8,         // Mode 1  
  K3__000_,   KEY_UP,        // Mode 2  
  K5_00000,   KEY_F2,        // Mode 3  
  //--------------------------------------------------
  K5_00100,   KEY_P,         // [SPACE]+[O]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   KEY_P,         // Mode 3  
  //--------------------------------------------------
  K5_00010,   KEY_I,         // [I]
  K5_00000,   KEY_9,         // Mode 1  
  K3__000_,   KEY_PAGE_DOWN, // Mode 2  
  K5_00000,   KEY_F3,        // Mode 3  
  //--------------------------------------------------
  K5_00010,   KEY_J,         // [SPACE]+[I]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00001,   KEY_BACKSPACE, // [Backspace]
  K5_00000,   KEY_BACKSPACE, // Mode 1  
  K3__000_,   KEY_BACKSPACE, // Mode 2  
  K5_00000,   KEY_BACKSPACE, // Mode 3  
  //--------------------------------------------------
  K5_00001,   KEY_DELETE,    // [SPACE]+[Backspace]
  K5_00000,   KEY_DELETE,    // Mode 1  
  K3__000_,   KEY_DELETE,    // Mode 2  
  K5_10000,   KEY_DELETE,    // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_H,         // [H]   
  K5_10000,   KEY_0,         // Mode 1  
  K3__000_,   0,             // Mode 2
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_C,         // [SPACE]+[H]   
  K5_10000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_T,         // [T]     
  K5_01000,   KEY_4,         // Mode 1                
  K3__000_,   KEY_LEFT,      // Mode 2  
  K5_00000,   KEY_F4,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_Y,         // [SPACE]+[T]     
  K5_01000,   0,             // Mode 1                
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_E,         // [E]    
  K5_00100,   KEY_5,         // Mode 1              
  K3__000_,   KEY_DOWN,      // Mode 2  
  K5_00000,   KEY_F5,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_W,         // [SPACE]+[E]    
  K5_00100,   0,             // Mode 1              
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_N,         // [N]     
  K5_00010,   KEY_6,         // Mode 1              
  K3__000_,   KEY_RIGHT,     // Mode 2  
  K5_00000,   KEY_F6,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_M,         // [SPACE]+[N]     
  K5_00010,   0,             // Mode 1              
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_S,         // [S]           
  K5_00001,   KEYPAD_PLUS,   // Mode 1              
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_G,         // [SPACE]+[S]           
  K5_00001,   KEYPAD_ASTERIX,// Mode 1              
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_D,         // [D]     
  K5_00000,   KEY_1,         // Mode 1              
  K3__100_,   KEY_HOME,      // Mode 2  
  K5_00000,   KEY_F7,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_B,         // [SPACE]+[D]     
  K5_00000,   0,             // Mode 1              
  K3__100_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_R,         // [R]     
  K5_00000,   KEY_2,         // Mode 1              
  K3__010_,   KEY_F2,        // Mode 2  
  K5_00000,   KEY_F8,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_V,         // [SPACE]+[R]     
  K5_00000,   0,             // Mode 1              
  K3__010_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_L,         // [L]     
  K5_00000,   KEY_3,         // Mode 1           
  K3__001_,   KEY_END,       // Mode 2  
  K5_00000,   KEY_F9,        // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_K,         // [SPACE]+[L]     
  K5_00000,   0,             // Mode 1           
  K3__001_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   255,           // [SHIFT]
  K5_00000,   255,           // Mode 1           
  K3__000_,   255,           // Mode 2
  K5_01000,   255,           // Mode 3  
  //--------------------------------------------------
  K5_00000,   254,           // [SPACE]+[SHIFT]
  K5_00000,   254,           // Mode 1           
  K3__000_,   254,           // Mode 2
  K5_11000,   254,           // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_COMMA,     // [,]          
  K5_00000,   0,             // Mode 1              
  K3__000_,   0,             // Mode 2  
  K5_00100,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   253,           // [SPACE]+[,]          
  K5_00000,   253,           // Mode 1              
  K3__000_,   253,           // Mode 2  
  K5_10100,   253,           // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_PERIOD,    // [.]         
  K5_00000,   KEY_EQUAL,     // Mode 1
  K3__000_,   0,             // Mode 2  
  K5_00010,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   252,           // [SPACE]+[.]         
  K5_00000,   252,           // Mode 1
  K3__000_,   252,           // Mode 2  
  K5_10010,   252,           // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_ENTER,     // [ENTER]
  K5_00000,   0,             // Mode 1           
  K3__000_,   0,             // Mode 2
  K5_00001,   0,             // Mode 3  
  //--------------------------------------------------
  K5_00000,   KEY_SPACE,     // [SPACE]+[ENTER]
  K5_00000,   0,             // Mode 1           
  K3__000_,   0,             // Mode 2
  K5_10001,   0,             // Mode 3  
  //--------------------------------------------------
  // *** Double Button Press ***
  //--------------------------------------------------  
  K5_11000,   241,           // []+[]
  K5_00000,   241,           // Mode 1  
  K3__000_,   241,           // Mode 2  
  K5_00000,   241,           // Mode 3  
  //--------------------------------------------------  
  K5_11000,   KEY_TAB,       // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_01100,   KEY_Q,         // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_01100,   KEY_UP,        // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00110,   KEY_X,         // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00110,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00011,   KEY_Z,         // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00011,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // []+[]
  K5_11000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   KEY_LEFT,      // [SPACE]+[]+[]
  K5_11000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_01100,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   KEY_DOWN,      // [SPACE]+[]+[]
  K5_01100,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00110,   0,             // Mode  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   KEY_RIGHT,     // [SPACE]+[E]+[M]
  K5_00110,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00011,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00011,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00000,   0,             // Mode 1  
  K3__110_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__110_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00000,   0,             // Mode 1  
  K3__011_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__011_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_01100,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_11100,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00110,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10110,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00000,   0,             // []+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00011,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   0,             // [SPACE]+[]+[]
  K5_00000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10011,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_10000,   KEY_LEFT_BRACE,// []+[]
  K5_10000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_01000,   SK_LBRKT,      // [SPACE]+[]+[]
  K5_01000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00100,   SK_BAR,        // [SPACE]+[]+[]
  K5_00100,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00010,   SK_RBRKT,      // []+[]
  K5_00010,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00001,   KEY_RIGHT_BRACE, // []+[]
  K5_00001,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
   //--------------------------------------------------  
  K5_00000,   SK_LCBRKT,     // [SPACE]+[]+[]
  K5_01000,   0,             // Mode 1  
  K3__100_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   SK_EXCLAMATION,// [SPACE]+[]+[]
  K5_00100,   0,             // Mode 1  
  K3__010_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00000,   SK_RCBRKT,     // []+[]
  K5_00010,   0,             // Mode 1  
  K3__001_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
 //--------------------------------------------------  
  K5_01000,   SK_LESS,       // []+[]
  K5_10000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_01000,   0,             // []+[]+[]
  K5_10000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00100,   KEY_SLASH,     // []+[]
  K5_01000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00100,   0,             // []+[]+[]
  K5_01000,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00100,   KEY_BACKSLASH, // []+[]
  K5_00010,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00100,   0,             // []+[]+[]
  K5_00010,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  K5_00010,   SK_GRTR,       // []+[]
  K5_00001,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_00000,   0,             // Mode 3  
  //--------------------------------------------------  
  K5_00010,   0,             // []+[]+[]
  K5_00001,   0,             // Mode 1  
  K3__000_,   0,             // Mode 2  
  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    

//  K5_00000,   0,             // []+[]
//  K5_00000,   0,             // Mode 1  
//  K3__000_,   0,             // Mode 2  
//  K5_00000,   0,             // Mode 3  
//  //--------------------------------------------------  
//  K5_00000,   0,             // [SPACE]+[]+[]
//  K5_00000,   0,             // Mode 1  
//  K3__000_,   0,             // Mode 2  
//  K5_10000,   0,             // Mode 3  
  //--------------------------------------------------    
  // END MARKER --------------------------------------
  //--------------------------------------------------    
  255 }; // END MARKER
  //===================================================
  
