void loop() {
  // value = EEPROM.read(address);
  // EEPROM.write(address,value);

  //(B5)(B6)(D7)(B7)(C6)
  // F4  F1  F0  B0  B1
  // F5  F6  E6  D2  B2
  //[F7] B4  D4  C7 [B3]
  //[  ] D6  D5  D3 [  ]

  Now = millis();

  // Write Mode LEDs
  if (Mode == 0) PORTB |= B00100000; else PORTB &= B11011111;    
  if (Mode == 1) PORTB |= B01000000; else PORTB &= B10111111;
  if (Mode == 2) PORTD |= B10000000; else PORTD &= B01111111;
  if (Mode == 3) PORTB |= B10000000; else PORTB &= B01111111;
  if (Mode == 4) PORTC |= B01000000; else PORTC &= B10111111;

  for (x=0; x<18; x++) oBut[x] = nBut[x];
  // Top Row =====================================
  nBut[0]  = ((PINF & B00010000) == 0);  // F4
  nBut[1]  = ((PINF & B00000010) == 0);  // F1
  nBut[2]  = ((PINF & B00000001) == 0);  // F0
  nBut[3]  = ((PINB & B00000001) == 0);  // B0
  nBut[4]  = ((PINB & B00000010) == 0);  // B1
  // Row 2 =======================================
  nBut[5]  = ((PINF & B00100000) == 0);  // F5
  nBut[6]  = ((PINF & B01000000) == 0);  // F6
  nBut[7]  = ((PINE & B01000000) == 0);  // E6
  nBut[8]  = ((PIND & B00000100) == 0);  // D2
  nBut[9]  = ((PINB & B00000100) == 0);  // B2
  // Row 3 =======================================
  nBut[10] = ((PINB & B00010000) == 0);  // B4
  nBut[11] = ((PIND & B00010000) == 0);  // D4
  nBut[12] = ((PINC & B10000000) == 0);  // C7
  // Row 4 =======================================
  nBut[13] = ((PINF & B10000000) == 0);  // F7
  nBut[14] = ((PIND & B01000000) == 0);  // D6
  nBut[15] = ((PIND & B00100000) == 0);  // D5
  nBut[16] = ((PIND & B00001000) == 0);  // D3
  nBut[17] = ((PINB & B00001000) == 0);  // B3
  for (x=0; x<18; x++) {
		if (nBut[x] != oBut[x]) ButOK[x] = Now;
    else if ((Now - ButOK[x]) > 15) But[x] = nBut[x];
  }
	
  ioRHS = iRHS;
  iBit  = 1;
  iRHS  = 0;
  for (x=0; x<13; x++) {
    if (But[x]) iRHS |=  iBit;
    iBit <<= 1;
  } 

  // Left hand sent from other keyboard as debounced matrix
  ioLHS = iLHS;
  iLHS  = LH[0] | (LH[1] << 5) | (LH[2] << 10);
 
  // Modifiers are taken from both hands
  ioMOD = iMOD;
  iMOD  = LH[3];
  if (But[13]) iMOD |= 0x0100;
  if (But[14]) iMOD |= 0x0200;
  if (But[15]) iMOD |= 0x0400;
  if (But[16]) iMOD |= 0x0800;     
  if (But[17]) iMOD |= 0x1000;

  iSendCode = 0;

  if ((ioLHS != iLHS) || (ioRHS != iRHS) || (ioMOD != iMOD)) {
		Serial.print(iLHS);
		Serial.print(" ");
		Serial.print(iRHS);
		Serial.print(" ");
		Serial.println(iMOD);
			
    if (iMOD != ioMOD) {
      iDown = iMOD  & (ioMOD ^ 0xFFFF);  // Down
      iUp   = ioMOD & (iMOD  ^ 0xFFFF);  // Up
      if  (iDown & 0x1111) bModOnly = true;
      if ((iDown & 0xEEEE) || (iLHS != 0) || (iRHS != 0)) bModOnly = false;
      if ((  iUp & 0x0110) && bModOnly ) Send[1] = KEY_SPACE;
      if ((  iUp & 0x1000) && bModOnly ) Send[1] = KEY_ENTER;
      if  (  iUp & 0x0800) Send[1] = (iMOD & 0x0110) ? SK_COLON : KEY_PERIOD;
      if  (  iUp & 0x0400) Send[1] = (iMOD & 0x0110) ? KEY_SEMICOLON : KEY_COMMA;
    } 

    if (ioLHS != iLHS) {      
      iDown  = iLHS  & (ioLHS ^ 0xFFFF);  // Down
      iUp    = ioLHS & (iLHS  ^ 0xFFFF);  // Up
      if (iDown != 0) {
        bModOnly  = false;
        iBit      = 1;
        iSendCode = 1;
        while ((iDown & iBit) == 0) { iBit <<= 1; iSendCode += 2; }
      } 
    }
    if (ioRHS != iRHS) {
      iDown  = iRHS  & (ioRHS ^ 0xFFFF);  // Down
      iUp    = ioRHS & (iRHS  ^ 0xFFFF);  // Up
      if (iDown != 0) {
        bModOnly  = false;
        iBit      = 1;
        iSendCode = 2;
        while ((iDown & iBit) == 0) { iBit <<= 1; iSendCode += 2; }
      }        
    }
  }
  if (iSendCode > 0) {
		iSendCode--;
    if      (iMOD & 0x0110) Send[1] = KeyMod1[iSendCode];
    else if (iMOD & 0x1001) Send[1] = KeyMod2[iSendCode];
    else Send[1] = KeyStd[iSendCode];
  }
  // +-------------------------------------------------+  
  // | Send Characters to computer using USB functions |
  // +-------------------------------------------------+
  if (Send[1] > 0) {
    if (Send[1] < 240) {
      Mod[1]  = 0;
      if (iMOD > 0) {
        if ((iMOD & 0x0208) > 0) Mod[1]  = MODIFIERKEY_SHIFT;
        if ((iMOD & 0x0004) > 0) Mod[1] |= MODIFIERKEY_CTRL;
        if ((iMOD & 0x0002) > 0) Mod[1] |= MODIFIERKEY_ALT;
      }
      if ((Send[1] > 0xA5) && (Send[1] < 0xDF)) {
        switch ((char)Send[1]) {
          case SK_LBRKT:  Send[1] = KEY_9;           Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_0;           Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          case SK_LCBRKT: Send[1] = KEY_LEFT_BRACE;  Mod[1] = MODIFIERKEY_SHIFT;
                          Send[2] = KEY_RIGHT_BRACE; Mod[2] = MODIFIERKEY_SHIFT;
                          Send[3] = KEY_LEFT;        Mod[3] = 0;
                          break;
          default:        Send[1] -= 0x90;           Mod[1] = MODIFIERKEY_SHIFT;
                          break;
        }
      } 
      else {
        switch (Send[1]) {
          case (char)KEY_LEFT_BRACE: Send[1] = KEY_LEFT_BRACE;  Mod[1] = 0;
                                     Send[2] = KEY_RIGHT_BRACE; Mod[2] = 0;
                                     Send[3] = KEY_LEFT;        Mod[3] = 0;
                                     break;
        }
      }
      Keyboard.set_modifier(Mod[1]);
      Keyboard.set_key1(Send[1]);
      Keyboard.send_now();
      Send[0] = Send[1];
      SendOld = Send[1];
      Send[1] = 0;
      if (Send[2] != 0) {
        Keyboard.set_modifier(Mod[2]);
        Keyboard.set_key1(Send[2]);
        Keyboard.send_now();
        Send[2] = 0;
        Mod[2]  = 0;
      }
      if (Send[3] != 0) {
        // Send the cursor left with no modifier
        Keyboard.set_modifier(Mod[3]);
        Keyboard.set_key1(Send[3]);
        Keyboard.send_now();
        Send[3] = 0;
        Mod[3]  = 0;
      }
      Keyboard.set_modifier(0);
      Keyboard.set_key1(0);
      Keyboard.send_now();
    }
  }
}
