// OneHand V0.8 Master

#include <Wire.h>

//#include <EEPROM.h>

#include "K5_xxxxx.h"

//byte  Row[]    = { 0, 0, 0, 0, 0 };

byte  i,x;
byte  Keys;
byte  Send[4]  = {0, 0, 0, 0};
byte  Mod[4]   = {0, 0, 0, 0};
byte  SendOld  = 0;

byte  ModKey   = 0;
byte  oMod     = 0;
int   Ptr      = 0;
byte  QuitLoop = false;
byte  Offset   = 0;
byte  Mode     = 0;

byte siRowBit;
byte LH[4];
byte RH[4];
byte oLH[4];
byte oRH[4];

boolean nBut[18];
boolean oBut[18];
boolean But[18];

unsigned int iBit  = 0;
unsigned int iRHS  = 0;
unsigned int iLHS  = 0;
unsigned int iMOD  = 0;
unsigned int ioRHS = 0;
unsigned int ioLHS = 0;
unsigned int ioMOD = 0;
unsigned int iDown = 0;     
unsigned int iUp   = 0;     

unsigned int iSendCode = 0;

byte bModOnly    = false;

long  Now;
long  ButOK[18];

// == Modified Keys - Generates Shift + Another key to generate
#define SK_EXCLAMATION (0x90 + KEY_1)
#define SK_AT          (0x90 + KEY_2)
#define SK_HASH        (0x90 + KEY_3)
#define SK_DOLLAR      (0x90 + KEY_4)
#define SK_PERCENT     (0x90 + KEY_5)
#define SK_CAROT       (0x90 + KEY_6)
#define SK_AMP         (0x90 + KEY_7)
#define SK_STAR        (0x90 + KEY_8)
#define SK_LBRKT       (0x90 + KEY_9)
#define SK_RBRKT       (0x90 + KEY_0)
#define SK_Underline   (0x90 + KEY_MINUS)
#define SK_LCBRKT      (0x90 + KEY_LEFT_BRACE)
#define SK_RCBRKT      (0x90 + KEY_RIGHT_BRACE)
#define SK_QMARK       (0x90 + KEY_SLASH)
#define SK_BAR         (0x90 + KEY_BACKSLASH)
#define SK_LESS        (0x90 + KEY_COMMA) 
#define SK_GRTR        (0x90 + KEY_PERIOD)
#define SK_DQUOTE      (0x90 + KEY_QUOTE)
#define SK_COLON       (0x90 + KEY_SEMICOLON)

#define KEY_PD          KEY_PAGE_DOWN
#define KEY_PU          KEY_PAGE_UP
#define KEY_BS          KEY_BACKSPACE

// ====== Cursor Keys ======
// UP, DOWN, LEFT, RIGHT, HOME, END, PAGE UP, PAGE DOWN, TAB
// ====== Normal Keys ======
// Letters: KEY_A  .. KEY_Z
// Numbers: KEY_0  .. KEY_9
// FN Keys: KEY_F1 .. KEY_F12
// KEYPAD_0 .. KEYPAD_9
// KEY_ENTER	    	KEY_ESC	    		KEY_BACKSPACE   KEY_TAB
// KEY_SPACE	    	KEY_MINUS	    	KEY_EQUAL	    	KEY_LEFT_BRACE
// KEY_RIGHT_BRACE  KEY_BACKSLASH   KEY_NUMBER	    KEY_SEMICOLON
// KEY_QUOTE	    	KEY_TILDE       KEY_COMMA	    	KEY_PERIOD
// KEY_SLASH	    	KEY_CAPS_LOCK   KEY_PRINTSCREEN KEY_SCROLL_LOCK
// KEY_PAUSE	    	KEY_INSERT	    KEY_HOME	    	KEY_PAGE_UP
// KEY_DELETE	    	KEY_END	    		KEY_PAGE_DOWN   KEY_RIGHT
// KEY_LEFT	    		KEY_DOWN	    	KEY_UP	    		KEY_NUM_LOCK
// KEYPAD_SLASH	    KEYPAD_ASTERIX  KEYPAD_MINUS    KEYPAD_PLUS
// KEYPAD_ENTER     KEYPAD_PERIOD

//  [Tab][ J ][ P ][ F ][ K ]   [ B ][ C ][ V ][ X ][B S]
//  [ S ][ N ][ H ][ T ][ R ]   [ U ][ A ][ E ][ O ][ I ]
//       [ M ][ W ][ L ]             [ D ][ Y ][ G ]     
//
static const byte KeyStd[] = {
  KEY_TAB,		KEY_B,
  KEY_J,			KEY_U,
  KEY_P,			KEY_V,
  KEY_R,			KEY_X,
  KEY_K,			KEY_BACKSPACE,
// -----------------------------
  KEY_S,    	KEY_C,
  KEY_N,    	KEY_A,
  KEY_H,    	KEY_E,
  KEY_T,    	KEY_O,
  KEY_F,    	KEY_I,
// -----------------------------
  KEY_M,    	KEY_D,
  KEY_W,    	KEY_Y,
  KEY_L,    	KEY_G };

// KeyMod1 uses the thumb key to select the number and cursor keys
//
//  [ESC][HOM][UP ][END][ Z ]   [P.U][ 7 ][ 8 ][ 9 ][DEL]
//  [   ][LFT][DWN][RGT][ Q ]   [P.D][ 4 ][ 5 ][ 6 ][ 0 ]
//       [   ][   ][   ]             [ 1 ][ 2 ][ 3 ]     
//
static const byte KeyMod1[] = {
  KEY_ESC,		KEY_PAGE_UP,
  KEY_HOME,		KEY_7,
  KEY_UP,			KEY_8,
  KEY_END,		KEY_9,
  KEY_Z,  		KEY_DELETE,
// -----------------------------
  0,					KEY_PAGE_DOWN,
  KEY_LEFT,		KEY_4,
  KEY_DOWN,		KEY_5,
  KEY_RIGHT,	KEY_6,
  KEY_Q,			KEY_0,  
// -----------------------------
  0,					KEY_1,
  0,					KEY_2,
  0,					KEY_3 };

// KeyMod2 uses the pinky key to select alternative functions
//
//  [ESC][HOM][UP ][END][ Z ]   [   ][ () ][ ) ][   ][   ]
//  [   ][LFT][DWN][RGT][ Q ]   [   ][ [] ][ ] ][   ][   ]
//       [   ][   ][   ]             [ {} ][ ) ][   ]     
//
static const byte KeyMod2[] = {
  KEY_ESC,		0,
  KEY_HOME,		SK_LBRKT,
  KEY_UP,			SK_RBRKT,
  KEY_END,		0,
  KEY_Z,			KEY_DELETE,
// -----------------------------
  0,					0,
  KEY_LEFT,		KEY_LEFT_BRACE,
  KEY_DOWN,		KEY_RIGHT_BRACE,
  KEY_RIGHT,	0,
  0,					0,
// -----------------------------
  0,					SK_LCBRKT,
  0,					SK_RBRKT,
  0,					0 };
	
// KeyMod3 uses the pinky plus thumb keys to select alternative functions
//
//  [ESC][HOM][UP ][END][ Z ]   [P.U][ 7 ][ 8 ][ 9 ][DEL]
//  [   ][LFT][DWN][RGT][ Q ]   [P.D][ 4 ][ 5 ][ 6 ][ 0 ]
//       [   ][   ][   ]             [ 1 ][ 2 ][ 3 ]     
//
static const byte KeyMod3[] = {
  0,      		0,
  0,      		0,
  0,      		0,
  0,      		0,
  0,      		0,  
// -----------------------------
  0,      		0,
  0,   				0,
  0,					0,
  0,      		0,
  0,      		0,
// -----------------------------
  0,      		0,
  0,      		0,
  0,      		0 };

//===================================================
//