void setup() {
  // Data Direction Registers - 0: Input, 1: Output  
  DDRB  = B11100000;				// B5 B6 B7
  DDRC  = B01000000;				// C6
  DDRD  = B10000000;				// D7
  DDRE  = B00000000;				//
  DDRF  = B00000000;    		//
  // Data Output Registers - Controls Pull-Up On Inputs & Controls Output
  PORTB = B00011111;				// B0 B1 B2 B3 B4 B6
  PORTC = B10111111;				// C7
  PORTD = B01111111;				// D1 D2 D3 D4 D5 D6
  PORTE = B11111111;				// E6
  PORTF = B11111111;				// F0 F1 F4 F5 F6 F7
  Serial.begin(9600);				// USB is always 12 Mbit/sec

  Wire.begin(4);						// join i2c bus with address #4
  Wire.onReceive(recvI2C);	// register event  
}

void recvI2C(int howMany) {
  byte v,x,r;

  while(Wire.available()) { // loop through all but the last
    x = Wire.read();        
    r = (x & B11100000) >> 5;
    if ((r > 0) && (r < 5)) LH[(r-1)] = (x & B00011111);
  }
}

